Package net.sf.saxon.java

## Class JavaPlatform

- java.lang.Object
- - net.sf.saxon.java.JavaPlatform

- All Implemented Interfaces:
    `Platform`
  Direct Known Subclasses:
    `JavaPlatformPE`

      public class JavaPlatform
      extends java.lang.Object
      implements Platform

  Implementation of the Platform class containing methods specific to the Java platform (as distinct from .NET). This is a singleton class with no instance data.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JavaPlatform()` | The constructor is called during the static initialization of the Configuration

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addFunctionLibraries​(FunctionLibraryList list, Configuration config, int hostLanguage)` | Add the platform-specific function libraries to a function library list.
    `boolean` | `canReturnCollationKeys​(StringCollator collation)` | Given a collation, determine whether it is capable of returning collation keys.
    `RegularExpression` | `compileRegularExpression​(Configuration config, java.lang.CharSequence regex, java.lang.String flags, java.lang.String hostLanguage, java.util.List<java.lang.String> warnings)` | Compile a regular expression
    `AtomicMatchKey` | `getCollationKey​(SimpleCollation namedCollation, java.lang.String value)` | Given a collation, get a collation key.
    `ExternalObjectType` | `getExternalObjectType​(Configuration config, java.lang.String uri, java.lang.String localName)` | Get a SchemaType representing a wrapped external (Java or .NET) object
    `java.lang.String` | `getInstallationDirectory​(java.lang.String edition, Configuration config)` | Return the name of the directory in which the software is installed (if available)
    `javax.xml.transform.Source` | `getParserSource​(PipelineConfiguration pipe, javax.xml.transform.stream.StreamSource input, int validation, boolean dtdValidation)` | Convert a StreamSource to either a SAXSource or a PullSource, depending on the native parser of the selected platform
    `java.lang.String` | `getPlatformSuffix()` | Get a suffix letter to add to the Saxon version number to identify the platform
    `java.lang.String` | `getPlatformVersion()` | Get the platform version
    `boolean` | `hasICUCollator()` | No ICU features
    `boolean` | `hasICUNumberer()` | Indicate whether the ICU library is available and supports Numberers
    `void` | `initialize​(Configuration config)` | Perform platform-specific initialization of the configuration
    `boolean` | `isDotNet()` | Return true if this is the .NET platform
    `boolean` | `isJava()` | Return true if this is the Java platform
    `boolean` | `JAXPStaticContextCheck​(RetainedStaticContext retainedStaticContext, StaticContext sc)` | Checks if the supplied static context is an instance of the JAXP static context.
    `org.xml.sax.XMLReader` | `loadParser()` | Get a parser by instantiating the SAXParserFactory
    `org.xml.sax.XMLReader` | `loadParserForXmlFragments()` | Get a parser suitable for parsing XML fragments
    `StringCollator` | `makeCollation​(Configuration config, java.util.Properties props, java.lang.String uri)` | Obtain a collation with a given set of properties.
    `java.lang.ClassLoader` | `makeGeneratedClassLoader​(Configuration config, java.lang.Class thisClass)` | Return the class loader required to load the bytecode generated classes
    `ModuleURIResolver` | `makeStandardModuleURIResolver​(Configuration config)` | Make an instance of the default module URI resolver for this platform
    `StringCollator` | `makeUcaCollator​(java.lang.String uri, Configuration config)` | If available, make a collation using the ICU-J Library
    `void` | `registerAllBuiltInObjectModels​(Configuration config)` | Register all the external object models that are provided as standard with the relevant edition of Saxon for this Configuration
    `void` | `setDefaultSAXParserFactory​(Configuration config)` | Set the default XML parser to be loaded by the SAXParserFactory on this platform.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JavaPlatform

          public JavaPlatform()

      The constructor is called during the static initialization of the Configuration

  - ### Method Detail

    - #### JAXPStaticContextCheck

          public boolean JAXPStaticContextCheck​(RetainedStaticContext retainedStaticContext,
                                                StaticContext sc)

      Checks if the supplied static context is an instance of the JAXP static context. On Java we create namespace information from the JAXP XPath static context. On the .NET platform we do nothing.
      Specified by:
        `JAXPStaticContextCheck` in interface `Platform`
      Parameters:
        `retainedStaticContext` -
        `sc` -
      Returns:
        boolean
      Since:
        9.7.0.5

    - #### initialize

          public void initialize​(Configuration config)

      Perform platform-specific initialization of the configuration
      Specified by:
        `initialize` in interface `Platform`
      Parameters:
        `config` - the Saxon Configuration

    - #### isJava

          public boolean isJava()

      Return true if this is the Java platform
      Specified by:
        `isJava` in interface `Platform`
      Returns:
        true if this is the Java platform

    - #### isDotNet

          public boolean isDotNet()

      Return true if this is the .NET platform
      Specified by:
        `isDotNet` in interface `Platform`
      Returns:
        true if this is the .NET platform

    - #### getPlatformVersion

          public java.lang.String getPlatformVersion()

      Get the platform version
      Specified by:
        `getPlatformVersion` in interface `Platform`
      Returns:
        the version of the platform, for example "Java version 1.5.09"

    - #### getPlatformSuffix

          public java.lang.String getPlatformSuffix()

      Get a suffix letter to add to the Saxon version number to identify the platform
      Specified by:
        `getPlatformSuffix` in interface `Platform`
      Returns:
        "J" for Java, "N" for .NET

    - #### loadParser

          public org.xml.sax.XMLReader loadParser()

      Get a parser by instantiating the SAXParserFactory
      Specified by:
        `loadParser` in interface `Platform`
      Returns:
        the parser (XMLReader)

    - #### loadParserForXmlFragments

          public org.xml.sax.XMLReader loadParserForXmlFragments()

      Get a parser suitable for parsing XML fragments

      For background, see bugs 4127 and 4253. The problem is that to implement parse-xml-fragment(), we need to set an EntityResolver on the returned parser. But if an Apache catalog resolver is in use, the JAXP system properties may be set so that JAXP returns a custom XMLReader supplied by the catalog resolver, and that XMLReader ignores any attempt to set an EntityResolver. So we bypass JAXP and try to load the built-in parser within the JDK, which we know we can trust; only if this fails (presumably because this is not the Oracle JDK) do we fall back to using a JAXP-supplied parser. And if this turns out to ignore `setEntityResolver()` calls, we're hosed.

      Specified by:
        `loadParserForXmlFragments` in interface `Platform`
      Returns:
        the parser (XMLReader)

    - #### getParserSource

          public javax.xml.transform.Source getParserSource​(PipelineConfiguration pipe,
                                                            javax.xml.transform.stream.StreamSource input,
                                                            int validation,
                                                            boolean dtdValidation)

      Convert a StreamSource to either a SAXSource or a PullSource, depending on the native parser of the selected platform
      Specified by:
        `getParserSource` in interface `Platform`
      Parameters:
        `pipe` - the pipeline configuration
        `input` - the supplied StreamSource
        `validation` - indicates whether schema validation is required
        `dtdValidation` - indicates whether DTD validation is required
      Returns:
        the PullSource or SAXSource, initialized with a suitable parser, or the original input Source, if now special handling is required or possible. This implementation always returns the original input unchanged.

    - #### makeCollation

          public StringCollator makeCollation​(Configuration config,
                                              java.util.Properties props,
                                              java.lang.String uri)
                                       throws XPathException

      Obtain a collation with a given set of properties. The set of properties is extensible and variable across platforms. Common properties with example values include lang=ed-GB, strength=primary, case-order=upper-first, ignore-modifiers=yes, alphanumeric=yes. Properties that are not supported are generally ignored; however some errors, such as failing to load a requested class, are fatal.
      Specified by:
        `makeCollation` in interface `Platform`
      Parameters:
        `config` - the configuration object
        `props` - the desired properties of the collation
        `uri` - the collation URI
      Returns:
        a collation with these properties
      Throws:
        `XPathException` - if a fatal error occurs

    - #### canReturnCollationKeys

          public boolean canReturnCollationKeys​(StringCollator collation)

      Given a collation, determine whether it is capable of returning collation keys. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are equal under the equals() method.
      Specified by:
        `canReturnCollationKeys` in interface `Platform`
      Parameters:
        `collation` - the collation, provided as a Comparator
      Returns:
        true if this collation can supply collation keys

    - #### getCollationKey

          public AtomicMatchKey getCollationKey​(SimpleCollation namedCollation,
                                                java.lang.String value)

      Given a collation, get a collation key. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are compare correctly under the equals() method.
      Specified by:
        `getCollationKey` in interface `Platform`
      Parameters:
        `namedCollation` - the collation in use
        `value` - the string whose collation key is required
      Returns:
        a representation of the collation key, such that two collation keys are equal() if and only if the string values they represent are equal under the specified collation.
      Throws:
        `java.lang.ClassCastException` - if the collation is not one that is capable of supplying collation keys (this should have been checked in advance)

    - #### hasICUCollator

          public boolean hasICUCollator()

      No ICU features
      Specified by:
        `hasICUCollator` in interface `Platform`
      Returns:
        true if the ICU library class for collations appears to be loaded

    - #### hasICUNumberer

          public boolean hasICUNumberer()

      Description copied from interface: `Platform`
      Indicate whether the ICU library is available and supports Numberers
      Specified by:
        `hasICUNumberer` in interface `Platform`
      Returns:
        true if the ICU library class for rule-based numbering appears to be loaded

    - #### makeUcaCollator

          public StringCollator makeUcaCollator​(java.lang.String uri,
                                                Configuration config)
                                         throws XPathException

      If available, make a collation using the ICU-J Library
      Specified by:
        `makeUcaCollator` in interface `Platform`
      Parameters:
        `uri` - the collation URI (which will always be a UCA collation URI as defined in XSLT 3.0)
        `config` - the Saxon configuration
      Returns:
        the collation, or null if not available
      Throws:
        `XPathException` - if the URI is malformed in some way

    - #### compileRegularExpression

          public RegularExpression compileRegularExpression​(Configuration config,
                                                            java.lang.CharSequence regex,
                                                            java.lang.String flags,
                                                            java.lang.String hostLanguage,
                                                            java.util.List<java.lang.String> warnings)
                                                     throws XPathException

      Compile a regular expression
      Specified by:
        `compileRegularExpression` in interface `Platform`
      Parameters:
        `config` - the Saxon configuration
        `regex` - the regular expression as a string
        `flags` - the value of the flags attribute
        `hostLanguage` - one of "XSD10", "XSD11", "XP20" or "XP30". Also allow combinations, e.g. "XP20/XSD11".
        `warnings` - if supplied, may capture warnings from the regular expression compiler
      Returns:
        the compiled regular expression
      Throws:
        `XPathException` - if the regular expression or the flags are invalid

    - #### addFunctionLibraries

          public void addFunctionLibraries​(FunctionLibraryList list,
                                           Configuration config,
                                           int hostLanguage)

      Add the platform-specific function libraries to a function library list. This version of the method does nothing
      Parameters:
        `list` - the function library list that is to be extended
        `config` - the Configuration
        `hostLanguage` - the host language, for example Configuration.XQUERY

    - #### getExternalObjectType

          public ExternalObjectType getExternalObjectType​(Configuration config,
                                                          java.lang.String uri,
                                                          java.lang.String localName)

      Description copied from interface: `Platform`
      Get a SchemaType representing a wrapped external (Java or .NET) object
      Specified by:
        `getExternalObjectType` in interface `Platform`
      Parameters:
        `config` - the Saxon Configuration
        `uri` - the namespace URI of the schema type
        `localName` - the local name of the schema type
      Returns:
        the SchemaType object representing this type

    - #### getInstallationDirectory

          public java.lang.String getInstallationDirectory​(java.lang.String edition,
                                                           Configuration config)

      Return the name of the directory in which the software is installed (if available)
      Specified by:
        `getInstallationDirectory` in interface `Platform`
      Parameters:
        `edition` - The edition of the software that is loaded ("HE", "PE", or "EE")
        `config` - the Saxon configuration
      Returns:
        the name of the directory in which Saxon is installed, if available, or null otherwise

    - #### registerAllBuiltInObjectModels

          public void registerAllBuiltInObjectModels​(Configuration config)

      Register all the external object models that are provided as standard with the relevant edition of Saxon for this Configuration
      Specified by:
        `registerAllBuiltInObjectModels` in interface `Platform`
      Parameters:
        `config` - the Saxon configuration
      Since:
        9.3

    - #### setDefaultSAXParserFactory

          public void setDefaultSAXParserFactory​(Configuration config)

      Set the default XML parser to be loaded by the SAXParserFactory on this platform. Needed because the Apache catalog resolver uses the SAXParserFactory to instantiate a parser, and if not customized this causes a failure on the .NET platform.
      Specified by:
        `setDefaultSAXParserFactory` in interface `Platform`
      Parameters:
        `config` - the Saxon configuration
      Since:
        9.4

    - #### makeStandardModuleURIResolver

          public ModuleURIResolver makeStandardModuleURIResolver​(Configuration config)

      Description copied from interface: `Platform`
      Make an instance of the default module URI resolver for this platform
      Specified by:
        `makeStandardModuleURIResolver` in interface `Platform`
      Parameters:
        `config` - the Saxon configuration
      Returns:
        an instance of ModuleURIResolver

    - #### makeGeneratedClassLoader

          public java.lang.ClassLoader makeGeneratedClassLoader​(Configuration config,
                                                                java.lang.Class thisClass)

      Return the class loader required to load the bytecode generated classes
      Specified by:
        `makeGeneratedClassLoader` in interface `Platform`
      Parameters:
        `config` - The saxon configuration
        `thisClass` - The class object generated
      Returns:
        the class loader object
      Since:
        9.6.0.3